<?php
// Inspired from yii builtin Captcha
// @author totoloco at gmail
// @site http://ushcompu.com.ar

require_once(dirname(__FILE__).'/trymath/trymath_class.php');

class ETryiimathAction extends CAction {
  const REFRESH_GET_VAR='refresh';
  const SESSION_VAR_PREFIX='Yii.ETryiimathAction.';
  public $trymath;

  public function run() {
    $session=Yii::app()->session;
    $session->open();
    $name=$this->getSessionKey();

    $this->trymath = new TryMath();
    $session[$name]=$this->trymath->getResult();

    $this->getVerifyCode($session);
    $this->renderAscii();
  }

  public function getVerifyCode($session) {
    $name=$this->getSessionKey();
    if($session[$name]===null) {
      $this->trymath = new TryMath();
      $session[$name]=$this->trymath->getResult();
    }
    return $session[$name];
  }

  public function validate($input) {
    $session=Yii::app()->session;
    $session->open();
    $code=$this->getVerifyCode($session);
    $valid=$input==$code;
    return $valid;
  }

  protected function getSessionKey() {
    return self::SESSION_VAR_PREFIX.Yii::app()->getId().'.'.$this->getController()->getUniqueId().'.'.$this->getId();
  }

  protected function renderAscii() {
    echo $this->trymath->fetch();
  }
}
